//
//  NSString+ECCore.h
//  ECFoundation
//
//  Created by Sam Deane on 11/08/2010.
//  Copyright 2011 Sam Deane, Elegant Chaos. All rights reserved.
//  This source code is distributed under the terms of Elegant Chaos's 
//  liberal license: http://www.elegantchaos.com/license/liberal
//

#import <Foundation/Foundation.h>


@interface NSString(ECCore)

- (NSData*)splitWordsIntoInts;
- (NSData*)splitWordsIntoFloats;
- (NSArray*)componentsSeparatedByMixedCaps;

- (NSString*)stringBySplittingMixedCaps;

+ (NSString*)stringByFormattingCount:(NSUInteger)count singularFormat:(NSString*)singularFormat pluralFormat:(NSString*)pluralFormat;
+ (NSString*)stringWithMixedCapsFromWords:(NSArray*)words initialCap:(BOOL)initialCap;
+ (NSString*)stringWithUppercaseFromWords:(NSArray*)words separator:(NSString*)separator;
+ (NSString*)stringWithLowercaseFromWords:(NSArray*)words separator:(NSString*)separator;
+ (NSString*)stringWithNewUUID;

- (NSString*)sha1Digest;

+ (NSString*)stringWithOrdinal:(NSInteger)ordinal;

@end
